package com.atguigu3.bean;

import java.sql.Date;

/**
 * @Author: ZZP
 * @Description:
 * ORM编程思想 (object relation mapping)
 * 一个数据表对应一个 java 类
 * 表中的一条记录对应 java 类的一个对象
 * 表中的一个字段对应 java 类的一个属性
 *
 * @Date: Created in 12:38 2021/6/16
 * @Version: 1.0
 **/
public class Customer {
    private int id;
    private String name;
    private String email;
    private Date birth;

    public Customer() {
    }

    public Customer(int id, String name, String email, Date birth) {
        this.id = id;
        this.name = name;
        this.email = email;
        this.birth = birth;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public Date getBirth() {
        return birth;
    }

    public void setBirth(Date birth) {
        this.birth = birth;
    }

    @Override
    public String toString() {
        return "Customer{" +
                "id=" + id +
                ", name='" + name + '\'' +
                ", email='" + email + '\'' +
                ", birth=" + birth +
                '}';
    }
}
