package com.atguigu3.preparedstatement.curd;

import com.atguigu3.util.JDBCUtils;

import java.sql.Connection;
import java.sql.PreparedStatement;

/**
 * @Author: ZZP
 * @Description:
 * 使用 PreparedStatement 来替换 Statement，实现对数据表的增删改查操作
 *
 * 增删改
 * 查
 *
 * @Date: Created in 10:34 2021/6/16
 * @Version: 1.0
 **/
public class PreparedStatementUpdateTest3 {
    public static void main(String[] args) {
        String sql = "delete from customers where id = ?";
        update(sql, 3);
    }

    // 通用的增删改操作
    public static void update(String sql, Object... args) { // sql中的占位符的个数与可变形参的长度相同
        Connection conn = null;
        PreparedStatement ps = null;
        try {
            // 1.获取数据库的连接
            conn = JDBCUtils.getConnection();

            // 2.预编译 sql 语句，返回 PreparedStatement 的实例
            ps = conn.prepareStatement(sql);

            // 3.填充占位符
            for (int i = 0; i < args.length; i++) {
                ps.setObject(i + 1, args[i]);
            }

            // 4.执行操作
            ps.execute();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            // 5.关闭资源
            JDBCUtils.closeResource(conn, ps);
        }
    }
}
