package com.atguigu4.exercise;

import com.atguigu3.util.JDBCUtils;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.util.Scanner;

/**
 * @Author: ZZP
 * @Description:
 * 练习题1：从控制台向数据库的表customers中插入一条数据，表结构如下：
 *
 * @Date: Created in 20:14 2021/6/17
 * @Version: 1.0
 **/
public class exercise1 {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入用户名：");
        String name = scanner.next();
        System.out.println("请输入email：");
        String email = scanner.next();
        System.out.println("请输入生日日期：");
        String birth = scanner.next();

        String sql = "insert into customers(name, email, birth)values(?,?,?)";
        int update = update(sql, name, email, birth);// 1992-09-08
        if (update > 0) {
            System.out.println("添加成功！");
        } else {
            System.out.println("添加失败！");
        }
    }

    // 通用的增删改操作
    public static int update(String sql, Object... args) { // sql中的占位符的个数与可变形参的长度相同
        Connection conn = null;
        PreparedStatement ps = null;
        try {
            // 1.获取数据库的连接
            conn = JDBCUtils.getConnection();

            // 2.预编译 sql 语句，返回 PreparedStatement 的实例
            ps = conn.prepareStatement(sql);

            // 3.填充占位符
            for (int i = 0; i < args.length; i++) {
                ps.setObject(i + 1, args[i]);
            }

            // 4.执行操作
            /**
             * ps.execute():
             * 如果执行的是查询操作，有返回值，则此方法返回 true
             * 如果执行的是增、删、改、查操作，没有返回值，则此方法返回 false
             */
            // 方式一：
            //ps.execute();

            // 方式二：
            return ps.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            // 5.关闭资源
            JDBCUtils.closeResource(conn, ps);
        }
        return 0;
    }
}
