package com.atguigu4.exercise;

import com.atguigu3.util.JDBCUtils;

import java.lang.reflect.Field;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.Scanner;

/**
 * @Author: ZZP
 * @Description:
 *
 * @Date: Created in 20:35 2021/6/17
 * @Version: 1.0
 **/
public class exercise2 {
    public static void main(String[] args) {
        //testInsert();

        //queryWithIDCardOrExamCard();

        //testDeleteByExamCard();

        testDeleteByExamCard1();
    }

    // 完成学生信息的删除功能
    public static void testDeleteByExamCard() {
        while (true) {
            System.out.println("请输入准考证号：");
            Scanner scanner = new Scanner(System.in);
            String ExamCard = scanner.next();
            // 查询指定准考证号的学生
            String sql = "select FlowID, Type,IDCard, ExamCard,StudentName, Location,Grade from examstudent where ExamCard = ?";
            Student student = getInstance(Student.class, sql, ExamCard);
            if (student == null) {
                System.out.println("查无此人！请重新输入：");
            } else {
                String sql1 = "delete from examstudent where ExamCard = ?";
                int deleteCount = update(sql1, ExamCard);
                if (deleteCount > 0) {
                    System.out.println("删除成功！");
                    break;
                } else {
                    System.out.println("删除失败！");
                }
            }
        }
    }

    // 完成学生信息的删除功能
    public static void testDeleteByExamCard1() {
        while (true) {
            System.out.println("请输入准考证号：");
            Scanner scanner = new Scanner(System.in);
            String ExamCard = scanner.next();
            String sql = "delete from examstudent where ExamCard = ?";
            int deleteCount = update(sql, ExamCard);
            if (deleteCount > 0) {
                System.out.println("删除成功！");
                break;
            } else {
                System.out.println("查无此人！请重新输入：");
            }
        }
    }

    // 输入身份证号或准考证号可以查询到学生的基本信息。
    public static void queryWithIDCardOrExamCard() {
        System.out.println("请输入你要查询的类型：");
        System.out.println("a.准考证号");
        System.out.println("b.身份证号");
        Scanner scanner = new Scanner(System.in);
        String selection = scanner.next();
        if ("a".equalsIgnoreCase(selection)) {
            System.out.println("请输入准考证号：");
            String ExamCard = scanner.next();

            String sql = "select FlowID, Type,IDCard, ExamCard,StudentName, Location,Grade from examstudent where ExamCard = ?";
            Student student = getInstance(Student.class, sql, ExamCard);
            if (student != null) {
                System.out.println(student);
            } else {
                System.out.println("输入的准考证号有误！");
            }
        } else if ("b".equalsIgnoreCase(selection)) {
            System.out.println("请输入身份证号：");

            System.out.println("请输入身份证号：");
            String IDCard = scanner.next();

            String sql = "select FlowID, Type,IDCard, ExamCard,StudentName, Location,Grade from examstudent where ExamCard = ?";
            Student student = getInstance(Student.class, sql, IDCard);
            if (student != null) {
                System.out.println(student);
            } else {
                System.out.println("输入的身份证号有误！");
            }
        } else {
            System.out.println("您的输入有误！请重新进入程序。");
        }
    }

    // 插入一个新的student 信息
    /*
        Type:
        IDCard:
        ExamCard:
        StudentName:
        Location:
        Grade:

    信息录入成功!
     */
    public static void testInsert() {
        Scanner scanner = new Scanner(System.in);
        System.out.print("四级 / 六级：");
        int Type = scanner.nextInt();
        System.out.print("身份证号：");
        String IDCard = scanner.next();
        System.out.print("准考证号：");
        String ExamCard = scanner.next();
        System.out.print("学生姓名：");
        String StudentName = scanner.next();
        System.out.print("所在城市：");
        String Location = scanner.next();
        System.out.print("学生成绩：");
        int Grade = scanner.nextInt();

        String sql = "insert into examstudent(Type, IDCard, ExamCard, StudentName, Location,Grade)values(?,?,?,?,?,?)";
        int update = update(sql, Type, IDCard, ExamCard, StudentName, Location, Grade);
        if (update > 0) {
            System.out.println("添加成功！");
        } else {
            System.out.println("添加失败！");
        }
    }

    /**
     * @Author: ZZP
     * @Date:2021/6/17
     * @Description: 通用的增删改操作
     */
    public static int update(String sql, Object... args) { // sql中的占位符的个数与可变形参的长度相同
        Connection conn = null;
        PreparedStatement ps = null;
        try {
            // 1.获取数据库的连接
            conn = JDBCUtils.getConnection();

            // 2.预编译 sql 语句，返回 PreparedStatement 的实例
            ps = conn.prepareStatement(sql);

            // 3.填充占位符
            for (int i = 0; i < args.length; i++) {
                ps.setObject(i + 1, args[i]);
            }

            // 4.执行操作
            return ps.executeUpdate();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            // 5.关闭资源
            JDBCUtils.closeResource(conn, ps);
        }
        return 0;
    }

    /**
     * @Author: ZZP
     * @Date:2021/6/17
     * @Description: 针对于不同表的通用的查询操作，返回表中的一条记录
     */
    public static <T> T getInstance(Class<T> clazz, String sql, Object... args) {
        Connection conn = null;
        PreparedStatement ps = null;
        ResultSet resultSet = null;
        try {
            conn = JDBCUtils.getConnection();

            // 2.预编译 sql 语句，返回 PreparedStatement 的实例
            ps = conn.prepareStatement(sql);

            // 3.填充占位符
            for (int i = 0; i < args.length; i++) {
                ps.setObject(i + 1, args[i]);
            }

            // 4.执行并返回结果集
            resultSet = ps.executeQuery();

            // 获取结果集的元数据：ResultSetMetaData
            ResultSetMetaData rsmd = resultSet.getMetaData();

            // 通过 ResultSetMetaData 获取结果集中的列数
            int columnCount = rsmd.getColumnCount();

            // 5.处理结果集
            if (resultSet.next()) {
                T t = clazz.newInstance();

                // 处理结果集一行数据中的每一个列
                for (int i = 0; i < columnCount; i++) {
                    // 获取列值
                    Object columnValue = resultSet.getObject(i + 1);

                    // 获取每个列的列名 getColumnName()
                    // 获取每个列的别名 getColumnLabel()
                    String columnLabel = rsmd.getColumnLabel(i + 1);

                    // 给 columnName 对象指定的某个属性，赋值为 columnValue : 通过反射
                    Field field = clazz.getDeclaredField(columnLabel);
                    field.setAccessible(true);
                    field.set(t, columnValue);
                }
                return t;
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            // 关闭资源
            JDBCUtils.closeResource(conn, ps, resultSet);
        }
        return null;
    }
}
