package com.atguigu2.dao;

import com.atguigu2.bean.Customer;

import java.sql.Connection;
import java.sql.Date;
import java.util.List;

/**
 * @Author: ZZP
 * @Date: Created in 10:59 2021/6/19
 * @Version: 1.0
 * @Description: 此接口用于规范针对于 customers 表的常用操作
 **/
public interface CustomerDAO {
    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 将 cust 对象添加到数据库中
     */
    void insert(Connection conn, Customer cust);

    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 根据指定的 id 删除表中的一条记录
     */
    void deleteByTd(Connection conn, int id);

    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 针对于内存中的 cust 对象，去修改数据表中的记录
     */
    void update(Connection conn, Customer cust);

    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 根据指定的 id 查询得到对应的 Customer 对象
     */
    Customer getCustomerById(Connection conn, int id);

    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 查询表中的所有记录构成的集合
     */
    List<Customer> getAll(Connection conn);

    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 返回数据表中数据的条目数
     */
    Long getCount(Connection conn);

    /**
     * @Author: ZZP
     * @Date:2021/6/19
     * @Version: 1.0
     * @Description: 返回数据表中的最大生日数
     */
    Date getMaxBirth(Connection conn);
}
