package com.atguigu4.connection;

import com.mchange.v2.c3p0.ComboPooledDataSource;
import com.mchange.v2.c3p0.DataSources;
import com.mchange.v2.c3p0.cfg.C3P0Config;
import org.junit.Test;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * @Author: ZZP
 * @Date: Created in 15:26 2021/6/19
 * @Version: 1.0
 * @Description:
 **/
public class C3P0Test {
    // 方式一：
    @Test
    public void testGetConnection() throws Exception {
        // 获取 C3P0 数据库连接池
        ComboPooledDataSource cpds = new ComboPooledDataSource();
        cpds.setDriverClass("com.mysql.cj.jdbc.Driver");
        cpds.setJdbcUrl("jdbc:mysql://localhost:3306/test?characterEncoding=utf-8&serverTimezone=UTC&rewriteBatchedStatements=true");
        cpds.setUser("root");
        cpds.setPassword("719238");

        // 通过设置相关的参数，对数据库连接池进行管理
        // 设置初始时数据库连接池中的连接数
        cpds.setInitialPoolSize(10);

        Connection conn = cpds.getConnection();
        System.out.println(conn);

        // 销毁 C3P0 数据库连接池
        DataSources.destroy(cpds);
    }

    // 方式二：使用配置文件
    @Test
    public void testGetConnection1() throws SQLException {
        ComboPooledDataSource cpds = new ComboPooledDataSource("helloC3P0");
        Connection conn = cpds.getConnection();
        System.out.println(cpds);
    }
}
