package com.atguigu4.connection;

import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.commons.dbcp2.BasicDataSourceFactory;
import org.junit.Test;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Properties;

/**
 * @Author: ZZP
 * @Date: Created in 16:50 2021/6/19
 * @Version: 1.0
 * @Description: 测试 DBCP 的数据库连接池技术
 **/
public class DBCPTest {
    // 方式一
    @Test
    public void testGetConnection() throws SQLException {
        // 创建 DBCP 的数据库连接池
        BasicDataSource source = new BasicDataSource();

        // 设置基本信息
        source.setDriverClassName("com.mysql.cj.jdbc.Driver");
        source.setUrl("jdbc:mysql://localhost:3306/test?characterEncoding=utf-8&serverTimezone=UTC&rewriteBatchedStatements=true");
        source.setUsername("root");
        source.setPassword("719238");

        // 设置其他涉及数据库连接池管理的相关属性
        source.setInitialSize(10);
        source.setMaxTotal(10);

        Connection conn = source.getConnection();

        System.out.println(conn);
    }

    // 方式二：使用配置文件
    @Test
    public void testGetConnection1() throws Exception {
        Properties pros = new Properties();

        // 方式一：
        InputStream is = ClassLoader.getSystemClassLoader().getResourceAsStream("dbcp.properties");
        // 方式二：
        //FileInputStream fs = new FileInputStream(new File("src/dbcp.properties"));

        pros.load(is);
        BasicDataSource source = BasicDataSourceFactory.createDataSource(pros);

        Connection conn = source.getConnection();

        System.out.println(conn);
    }
}
